var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import defaultOptions from '../defaultOptions';
import { SortDirection } from '../enums';
import { isMultipleSorting, isTripleStateSorting, sortColumns } from './SortUtils';
export var getUpdatedSortedColumns = function (columns, columnKey, sortingMode) {
    var newColumns = columns.map(function (c) { return (__assign({}, c)); });
    var curentColumn = newColumns.find(function (c) { return c.key === columnKey; });
    if (curentColumn) {
        var nextSortDirection = getNextSortDirection(curentColumn.sortDirection);
        if (isTripleStateSorting(sortingMode)
            && curentColumn.sortDirection
            && nextSortDirection === defaultOptions.columnSortDirection) {
            nextSortDirection = undefined;
        }
        if (!isMultipleSorting(sortingMode)) {
            newColumns.forEach(function (c) {
                delete c.sortDirection;
                delete c.sortIndex;
            });
        }
        if (nextSortDirection) {
            curentColumn.sortDirection = nextSortDirection;
            if (isMultipleSorting(sortingMode) && !curentColumn.sortIndex) {
                var sortedColumns = newColumns.filter(function (c) { return c.sortDirection; });
                curentColumn.sortIndex = sortedColumns.length + 1;
            }
        }
        else {
            delete curentColumn.sortDirection;
            delete curentColumn.sortIndex;
        }
        if (isMultipleSorting(sortingMode)) {
            var sortedColumns = sortColumns(newColumns);
            sortedColumns.forEach(function (c, i) {
                c.sortIndex = i + 1;
            });
        }
    }
    return newColumns;
};
export var getNextSortDirection = function (previousSortdirection) {
    var nextSortDirection;
    if (previousSortdirection) {
        nextSortDirection = previousSortdirection === SortDirection.Ascend
            ? SortDirection.Descend : SortDirection.Ascend;
    }
    else {
        nextSortDirection = defaultOptions.columnSortDirection;
    }
    return nextSortDirection;
};